%define _sysconfdir /etc
%define state_dir /lib/dev-state

Summary: Daemon for providing old entries in /dev with devfs
Name: devfsd
Exclusiveos: Linux
Version: 1.3.18
Release: 16mdk
License: GPL
URL: ftp://ftp.atnf.csiro.au/pub/people/rgooch/linux/daemons/devfsd/%{name}-v%{version}.tar.bz2
Group: System/Kernel and hardware
Source: %{name}-v%{version}.tar.bz2
Source1: devfs_fs.h.bz2
Source2: devfs_fs_kernel.h.bz2
Patch0: devfsd-1.3.18-cdrom-ida-rd-mdk.patch.bz2
Patch1: devfsd-1.3.18-mod-mdk.patch.bz2
Patch2: devfsd-1.3.18-mdkconf.patch.bz2
Patch3: devfsd-nsl.patch.bz2
BuildRoot: %{_tmppath}/%{name}-%{version}-build
Requires: initscripts >= 4.97-49mdk, dynamic >= 0.4-1mdk, pam
Prefix: /

%description
The devfsd programme is a daemon, run by the system boot
scripts which can provide for intelligent management of
device entries in the Device Filesystem (devfs).

As part of its setup phase devfsd creates certain symbolic
links which are compiled into the code. These links are
required by /usr/src/linux/Documentation/devices.txt. This
behaviour may change in future revisions.

devfsd will read the special control file .devfsd in a
mounted devfs, listening for the creation and removal of
device entries (this is termed a change operation). For
each change operation, devfsd can take many actions. The
daemon will normally run itself in the background and send
messages to syslog.

The opening of the syslog service is automatically delayed
until /dev/log is created.

At startup, before switching to daemon mode, devfsd will
scan the mounted device tree and will generate synthetic
REGISTER events for each leaf node.

%prep
%setup -q -n %{name}

%patch0 -p1 -b .cdrom
%patch1 -p1 -b .mdk
%patch2 -p1 -b .mdkconf
%patch3 -p1 -b .nsl

%build
%serverbuild
mkdir -p linux
bzcat %{SOURCE1} > linux/devfs_fs.h
bzcat %{SOURCE2} > linux/devfs_fs_kernel.h
ls -l linux
make all CFLAGS="%{optflags} -I."

%install
mkdir -p %{buildroot}/{sbin,%{_sysconfdir},/%{_mandir}/man{5,8},etc,%{state_dir}}
install -m 755 -s devfsd %{buildroot}/sbin/devfsd
install -m 644 devfsd.8 %{buildroot}/%{_mandir}/man8
install -m 644 devfsd.conf.5 %{buildroot}/%{_mandir}/man5
install -m 644 devfsd.conf %{buildroot}%{_sysconfdir}
install -m 644 modules.devfs %{buildroot}%{_sysconfdir}

%pre
[ -d /var/dev-state/ -a ! -e %{state_dir} ] && \
	/bin/mv /var/dev-state %{state_dir} || :
[ -d /var/lib/dev-state/ -a ! -e %{state_dir} ] && \
	/bin/mv /var/lib/dev-state %{state_dir} || :

%post
killall -HUP devfsd 2>/dev/null || :

%postun
[ "$1" = "0" ] && killall -TERM devfsd 2>/devnull || :

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%{_mandir}/man8/devfsd.8*
%{_mandir}/man5/devfsd.conf.5*
/sbin/devfsd
%dir %{state_dir}
%config(noreplace) %{_sysconfdir}/devfsd.conf
%config(noreplace) %{_sysconfdir}/modules.devfs

%changelog
* Sun Sep 23 2001 Frederic Lepied <flepied@mandrakesoft.com> 1.3.18-16mdk
- fixed sound devices permissions by calling pam_console_apply for them.

* Fri Sep 21 2001 Frederic Lepied <flepied@mandrakesoft.com> 1.3.18-15mdk
- fix names of printers devices.

* Thu Sep 20 2001 Frederic Lepied <flepied@mandrakesoft.com> 1.3.18-14mdk
- make_symlink: remove unlink before symlink but no message when the symlink
fail when it's the good file that's already pointed.
- GLOBAL symlink is rerouted to make_symlink

* Thu Sep 20 2001 Frederic Lepied <flepied@mandrakesoft.com> 1.3.18-13mdk
- comment call to part.script (too buggy)
- add the /dev/video symlink

* Wed Sep 19 2001 Frederic Lepied <flepied@mandrakesoft.com> 1.3.18-12mdk
- symlink <==> ln -sf.
- devfsd.conf unlink on UNREGISTER not to create devices on next boot.

* Wed Sep 19 2001 Pixel <pixel@mandrakesoft.com> 1.3.18-11mdk
- make rd/discX/* (DAC960) works

* Sat Sep 15 2001 Frederic Lepied <flepied@mandrakesoft.com> 1.3.18-10mdk
- fix devfsd.conf for part regexp and visor regexp.

* Thu Sep 13 2001 Frederic Lepied <flepied@mandrakesoft.com> 1.3.18-9mdk
- launch part.script when a new partition is detected.

* Tue Sep 11 2001 Pixel <pixel@mandrakesoft.com> 1.3.18-8mdk
- nicer handling of in directories symlinks (function make_symlink)
- make ida/ and rd/ works (cpqarray, cciss and DAC960)
    [updated patch0]

* Sun Sep  9 2001 Pixel <pixel@mandrakesoft.com> 1.3.18-7mdk
- modules.devfs: replace scsi-hosts with scsi_hostadapter

* Sat Sep  8 2001 Frederic Lepied <flepied@mandrakesoft.com> 1.3.18-6mdk
- don't mess up /lib/dev-state with REGISTER and UNREGISTER [updated patch2]

* Wed Sep  5 2001 Frederic Lepied <flepied@mandrakesoft.com> 1.3.18-5mdk
- added compatibility for cpqarray and DAC960 devices (not tested) [updated patch0].
- remove /lib/dev-state entry on UNREGISTER (Andrej Borsenkow) [updated patch2].

* Tue Sep  4 2001 Frederic Lepied <flepied@mandrakesoft.com> 1.3.18-4mdk
- added compatibility entry for Parallel port ATAPI generic devices (updated patch0).

* Tue Aug 28 2001 Frederic Lepied <flepied@mandrakesoft.com> 1.3.18-3mdk
- changed sr => scd for compatibility symlinks (updated patch0).
- removed autoloading of bttv and autoload sound-slot-0 instead of sound.

* Tue Aug 28 2001 Frederic Lepied <flepied@mandrakesoft.com> 1.3.18-2mdk
- reworked patch3 to handle DELETE events to clean /lib/dev-state entries.

* Fri Aug 24 2001 Frederic Lepied <flepied@mandrakesoft.com> 1.3.18-1mdk
- 1.3.18

* Fri Aug 24 2001 Pixel <pixel@mandrakesoft.com> 1.3.17-4mdk
- shut up the killall

* Thu Aug 23 2001 Frederic Lepied <flepied@mandrakesoft.com> 1.3.17-3mdk
- manage the usbmouse symlinks

* Wed Aug 22 2001 Frederic Lepied <flepied@mandrakesoft.com> 1.3.17-2mdk
- removed call to pam_console_apply to speed up boot in the meantime.

* Tue Aug 21 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.3.17-1mdk
- Fix build.
- 1.3.17.

* Mon Aug 20 2001 Frederic Lepied <flepied@mandrakesoft.com> 1.3.16-2mdk
- call pam_console_apply on device creation/removal.

* Thu Aug 16 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.3.16-1mdk
- new release

* Tue Aug 14 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.3.15-1mdk
- new release

* Wed Aug  8 2001 Frederic Lepied <flepied@mandrakesoft.com> 1.3.12-3mdk
- use dynamic scripts

* Tue Aug 07 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.3.12-2mdk
- remove warning on ia64
- fake rpmlint

* Wed Aug  1 2001 Frederic Lepied <flepied@mandrakesoft.com> 1.3.12-1mdk
- moved devices saving dir to /lib/dev-state to allow a separate /var partition.
- 1.3.12 (merged patches 3 and 5, updated source2)

* Wed Jul 11 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.3.11-4mdk
- typo fixes

* Tue Jul 10 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.3.11-3mdk
- use %%serverbuild
- nicely reload devfsd on update
- nicely stop it on uninstall
- move /var/dev-state to /var/lib/dev-state in order to be FHS complient
  [on update, move existing perms]
  add a macro for it
- add %%dir /var/lib/dev-state
- no more need to link /dev/video0 on /dev/video for xawtv
  (need to be tested with zapping)

* Tue Jun 19 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.3.11-2mdk
- minor spec fixes
- build release

* Tue Feb 06 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.3.11-1mdk
- new release
- remove glibc-2.2 hack as this release fix it

* Tue Jan 09 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.3.10-7mdk
- more ALSA stuff
- prevent devfsd to auto{save,load} permissions & ownerships
  on Unix98 ptys (/dev/pts)
- handle CD burners too

* Thu Jan 04 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.3.10-6mdk
- more stuff for videtext support
- comment my previous changes

* Thu Nov 23 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.3.10-5mdk
- enable devfs to save and restore /dev/ state in /var/dev-state
- document devfsd.conf to show how to force default permissions
  out of the kernel
- remove empty %%post

* Fri Nov 17 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.3.10-4mdk
- fix glibc22 compilation.

* Wed Jul 19 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.3.10-3mdk
- BM

* Mon Jul 17 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.3.10-2mdk
- fix from Stefan van der Eijk <s.vandereijk@chello.nl>
- make devfsd LM-update comliant (aka pixelization)


* Tue Jul 04 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.3.10-1mdk
- new release (argh ... why do he fix in a new release what i've just fixed
  !!! => suppres my previous patch as it is now in)
- let spec-helper compress man-page
- guillomization

* Tue Jul 04 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.3.9-2mdk
- automatically load modules when a process lookup a /dev entry (part1)
	(part2 is copying richard' aliases in /etc/conf.modules)
  

* Tue Jun 20 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.3.9-1mdk
- New release
- Add old cdrom entries (i'll remove those from /etc/rc.d/rc.sysinit which is
  eventually not their place)
- Use mandir macros for FHS compatibilty.
- Add URL

* Wed Apr 19 2000 Jeff Garzik <jgarzik@mandrakesoft.com> 1.3.5-1mdk
- version 1.3.5
- ditch mdk fixes patch

* Tue Apr 18 2000 Jeff Garzik <jgarzik@mandrakesoft.com> 1.3.4-1mdk
- version 1.3.4
- fix spec permissions

* Mon Apr 17 2000 Jeff Garzik <jgarzik@mandrakesoft.com> 1.3.3-1mdk
- version 1.3.3
- new BuildRoot

* Thu Mar 30 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.31-2mdk
- fix a typo in the release number :-(
- compiled against 2.3.99pre4-1
- patches for DrakX had been submited and integrated. Patches for rc.sysinit
  are currently tested.

* Thu Mar 23 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.31-1mdk
- fist mandrake spec: use spechelper
- by default, we provide compatiblity entries in /dev
  (DiskDrake won't like /dev/ide/host0/bus0/target0/lun0/part1 instead of
  /dev/hda1 ...)
- fix bad code compilation
- add loading of sound module when /dev/{mixer,dsp,...} is lookuped

